// thermo.js
// the only reason this is javascript is so that your lovely title
// can be centered at the top of the image scroll
// css does not (yet) accept arguments or variables etc.
//
// 2013-06-16 fixed offsets so the title appears correctly if the
//            thermometer is inside a table by summing offsets
//
// 2021-07  Well, you can now sort of pass arguments around inside
//          javascript. This script still functions, so I did not
//          bother to replace it.
//
// https://www.toptal.com/front-end/dynamic-css-with-custom-properties
// https://stackoverflow.com/questions/17893823/how-to-pass-parameters-to-css-classes

var myImage=document.getElementById("thermogif");
var thermoWidth=myImage.offsetWidth;
var thermoHeight=myImage.offsetHeight;
var left_of_image_sum = 0;
var top_of_image_sum = 0;

while(myImage!= document.body) {
     left_of_image_sum = left_of_image_sum + myImage.offsetLeft;
     top_of_image_sum = top_of_image_sum + myImage.offsetTop;
     myImage = myImage.offsetParent;
}

// center horizontally
var textWidth = document.getElementById("thermo_span").offsetWidth;
var horiz_center = left_of_image_sum + thermoWidth/2;
var left_edge = horiz_center - textWidth/2;

// center vertically. the space to work with is 50 pixels out of 720 total or ~7%
// center of ribbon at top is 4.93% of the height.  Call it 5%
var textHeight = document.getElementById("thermo_span").offsetHeight;
var top_edge = top_of_image_sum  + Math.ceil(thermoHeight*0.05) - Math.floor(textHeight/2);

// now print out the css style that places text on the ribbon
document.writeln("<style>");
document.writeln("#thermo_span { position:absolute\; text-align:center\; ");
document.writeln("color:red\; text-shadow:1px 1px red\;");
document.writeln("text-transform:capitalize\; font-weight:bold\;");
document.writeln("top:" +top_edge + "px\; left:" + left_edge + "px\; } ");
document.writeln("</style>");

// end of thermo.js
